/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    chario.c : FIFOХåեդ饯⥸塼       ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"fancnt.h"
#include	"h8_3694.h"

#define	OBUF_SIZE	(0x50)		/* ϥХåե 80Byte */
#define IBUF_SIZE	(0x30)		/* ϥХåե 48Byte */
#define	CHECK_RxD(x)	(x & 0x40)

/************************************************************************
 *                                                                  *
 ************************************************************************
/**** ؿ ****/
void	initCharIO();
void	setBlockingMode(int);
void	unsetBlockingMode(int);
int	obufInput(char);
int	obufInputs(char *, int);
int	obufOutput(char *);
int	obufOutputs(char *, int);
int	ibufInput(char);
int	ibufInputs(char *, int);
int	ibufOutput(char *);
int	ibufOutputs(char *, int);

/**** ѿ ****/
extern sysParam		sysp;
char	outbuf[OBUF_SIZE];		/* 80Byte */
char	inbuf[IBUF_SIZE];		/* 48byte */

/************************************************************************
 *    ɸϴؿ                                                      *
 *    putchar(int c)	->    putc(int c, STDOUT) : macro               *
 *    putc(int c, int fd)                                               *
 *    puts(char *s)                                                     *
 *    fputc(int c, int fd) -> putc(int c, int fd) : macro               *
 *    fputs(char *s, int fd)                                            *
 ************************************************************************/
int
putc(int c, int fd)
{
    if (sysp.sending == 0) {
        while(1) {
            if (SSR & 0x80) {
                TDR = (char)c;
                SSR = SSR & 0x7b;
                SCR3= 0x74;
                break;
            }
        }
    } else {
        if (obufInput((char)c) == 0)		/* Хåե */
            return 0;
    }
    return 1;
}

int
puts(char *string)
{
    int		i = 0;

    while(string[i]) {
	putc((unsigned int)(string[i++]), STDOUT);
    }
    return(i);
}

int
fputs(char *str, int fd)
{
    int		i = 0;
    while(*str) {
        putc((unsigned int)(*str), fd);
        str++;
        i++;
    }
    return i;
}

/************************************************************************
 *    ɸϴؿ                                                      *
 *    getchar() -> getc(STDIN)    : macro                               *
 *    getc(int fd)                                                      *
 *    gets(int fd)                                                      *
 *    fgetc(int fd) -> getc(int fd) : macro                             *
 *    fgets(int fd)                                                     *
 ************************************************************************/
int
getc(int fd)
{
    char	buf[2];
    int		n;

    n = ibufOutput(buf);
    if (n == 0)	buf[0] = 0;
    return (int)buf[0];
}

int
gets(char *buf)
{
    int		i = 0;

    i = 0;
    while(1) {
        if (ibufOutput(&buf[i]) == 0)	break;
        i++;
    }
    buf[i] = '\0';
    return i;
}

int
fgets(char *buf, int n, int fd)
{
    int		i = 0;

    i = 0;
    while(1) {
        if (ibufOutput(&buf[i]) == 0)	break;
        i++;
        if (i == n)			break;
    }
    buf[i] = '\0';
    return i;
}

/************************************************************************
 *                                                                *
 ************************************************************************/
void
initCharIO()
{
    sysp.nblk = 0;	/* blocking mode off */
    sysp.ob_sp = 0;	/* Output Buffer Start point reset */
    sysp.ob_ep = 0;	/* Output Buffer End point reset */
    sysp.ib_sp = 0;	/* Input Buffer Start point reset */
    sysp.ib_ep = 0;	/* Input Buffer End point reset */
    sysp.sending = 0;
}

void
setBlockingMode(int ch)
{
    sysp.nblk = 1;
}

void
unsetBlockingMode(int ch)
{
    sysp.nblk = 0;
}

int
checkOutBuf(void)
{
    if (sysp.ob_sp == sysp.ob_ep)	return 0;
    else				return 1;
}

/************************************************************************
 *    ϥХåե                                                      *
 ************************************************************************/
/**** ϥХåեؤ1ʸ̾ ****/
int
obufInput(char c)
{
    int		ep, rtn;

    stopirq();
    ep = (sysp.ob_ep + 1) & (OBUF_SIZE-1);
    if (ep == sysp.ob_sp) {
	rtn = 0;		/* Buffer  */
    } else {
        outbuf[sysp.ob_ep] = c;			/* ǡ */
        sysp.ob_ep = (sysp.ob_ep + 1) & (OBUF_SIZE-1);	/* ݥ󥿹 */
        rtn = 1;
    }
    startirq();
    return rtn;
}

/**** ϥХåեؤʸ ****/
int
obufInputs(char *str, int num)
{
    int		i, ep;
    
    for(i=0; i<num; i++) {
        ep = (sysp.ob_ep + 1) & (OBUF_SIZE-1);
        if (ep == sysp.ob_sp)	break;
        outbuf[ep] = *str;
        sysp.ob_ep = ep;
        str++;
    }
    return i;
}

/**** ϥХåե1ʸФ ****/
int
obufOutput(char *s)
{
    if (sysp.ob_sp == sysp.ob_ep) {			/* buffer ä */
        *s = '\0';
	return 0;
    }
    s[0] = outbuf[sysp.ob_sp];			/* ǡФ */
    sysp.ob_sp = (sysp.ob_sp + 1) & (OBUF_SIZE-1);	/* ݥ󥿹 */
    return 1;
}

/**** ϥХåեʸФ ****/
int
obufOutputs(char *s, int num)
{
    int		i;
    
    for(i=0; i<num; i++) {
        if (sysp.ob_sp == sysp.ob_ep) {
            break;
        }
        *s++ = outbuf[sysp.ob_sp];
        sysp.ob_sp = (sysp.ob_sp + 1) & (OBUF_SIZE-1);
    }

    return i;
}

/************************************************************************
 *    ϥХåե                                                      *
 ************************************************************************/
/**** ϥХåեؤ1ʸ̾ ****/
int
ibufInput(char c)
{
    inbuf[sysp.ib_ep] = c;				/* ǡ */
    sysp.ib_ep = (sysp.ib_ep + 1) & (IBUF_SIZE-1);	/* ݥ󥿹 */
    if (sysp.ib_ep == sysp.ib_sp)			/* 줿ŤΤä */
        sysp.ib_sp = (sysp.ib_sp + 1) & (IBUF_SIZE-1);
    return 1;
}

/**** ϥХåեؤʸ ****/
int
ibufInputs(char *str, int num)
{
    int		i, ep;
    
    for(i=0; i<num; i++) {
        inbuf[sysp.ib_ep] = *str;
        sysp.ib_ep = (sysp.ib_ep + 1) & (IBUF_SIZE-1);
        if (sysp.ib_ep == sysp.ib_sp)
            sysp.ib_sp = (sysp.ib_sp + 1) & (IBUF_SIZE-1);
        str++;
    }
    return i;
}

/**** ϥХåե1ʸФ ****/
int
ibufOutput(char *s)
{
    if (sysp.ib_sp == sysp.ib_ep)	return 0;	/* buffer ä */
    stopirq();
    s[0] = inbuf[sysp.ib_sp];			/* ǡФ */
    sysp.ib_sp = (sysp.ib_sp + 1) & (IBUF_SIZE-1);	/* ݥ󥿹 */
    startirq();
    return 1;
}

/**** ϥХåեʸФ ****/
int
ibufOutputs(char *s, int num)
{
    int		i;
    
    for(i=0; i<num; i++) {
        if (sysp.ib_sp == sysp.ib_ep) {
            break;
        }
        stopirq();
        *s++ = inbuf[sysp.ib_sp];
        sysp.ib_sp = (sysp.ib_sp + 1) & (IBUF_SIZE-1);
        startirq();
    }
    return i;
}
    
/* end of file */
